> ## Documentation Index
> Fetch the complete documentation index at: https://docs.endorlabs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# UpdateProject

> Updates the specified project with the information in the request body.



## OpenAPI

````yaml /api-reference/openapi.v3.json patch /v1/namespaces/{object.tenant_meta.namespace}/projects
openapi: 3.0.3
info:
  description: Integrate your application with Endor Labs using the REST API.
  title: Endor Labs REST API Reference
  version: '1.0'
servers:
  - url: https://api.endorlabs.com/
security: []
tags:
  - name: AISastCustomerContextService
  - name: APIKeyService
  - name: APIKeyValidatorService
  - name: ArtifactSignatureService
  - name: AuditLogService
  - name: AuthenticationLogService
  - name: AuthenticationService
  - name: AuthorizationPolicyService
  - name: BatchFileSegmentsService
  - name: BatchNotificationService
  - name: CallGraphDataService
  - name: CodeOwnersService
  - name: DependencyMetadataService
  - name: EndorIgnoreEntryService
  - name: ExporterService
  - name: FindingLogService
  - name: FindingService
  - name: HuggingFaceModelService
  - name: HuggingFaceOrganizationService
  - name: IPAddressPolicyService
  - name: IdentityProviderService
  - name: InstallationService
  - name: InvitationService
  - name: LicenseDependencyService
  - name: LicenseNoticesReportService
  - name: LicenseSummaryService
  - name: LinterResultService
  - name: MalwareService
  - name: MetricService
  - name: NamespaceService
  - name: NotificationService
  - name: NotificationTargetService
  - name: OnPremSchedulerService
  - name: PRCommentConfigService
  - name: PackageFirewallLogService
  - name: PackageLicenseOverrideService
  - name: PackageLicenseQueryService
  - name: PackageLicenseService
  - name: PackageManagerService
  - name: PackageVersionService
  - name: PluginBinaryService
  - name: PolicyService
  - name: PolicyTemplateService
  - name: ProjectService
  - name: ProvisioningResultService
  - name: QueryMalwareService
  - name: QueryService
  - name: QuerySimilarPackagesService
  - name: QueryVulnerabilityService
  - name: RegistryIngestionCheckpointService
  - name: RepositoryService
  - name: RepositoryVersionService
  - name: RuleSetImportService
  - name: SBOMExportService
  - name: SBOMImportService
  - name: SCMCredentialService
  - name: SavedQueryService
  - name: ScanLogRequestService
  - name: ScanProfileService
  - name: ScanResultService
  - name: ScanWorkflowResultService
  - name: ScanWorkflowService
  - name: SecretRuleService
  - name: SemgrepRuleService
  - name: SystemConfigService
  - name: TenantService
  - name: VEXExportService
  - name: VectorStoreService
  - name: VersionUpgradeService
  - name: VulnerabilityService
paths:
  /v1/namespaces/{object.tenant_meta.namespace}/projects:
    patch:
      tags:
        - ProjectService
      summary: UpdateProject
      description: Updates the specified project with the information in the request body.
      operationId: ProjectService_UpdateProject
      parameters:
        - description: >-
            Namespaces are a way to organize organizational units into virtual

            groupings of resources. Namespaces must be a fully qualified name,

            for example, the child namespace of namespace "endor.prod" called
            "app"

            is called "endor.prod.app".
          in: path
          name: object.tenant_meta.namespace
          required: true
          schema:
            type: string
          x-endor-name: Namespace
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ProjectServiceUpdateProjectBody'
        required: true
        x-originalParamName: body
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1Project'
          description: A successful response.
        default:
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/googlerpcStatus'
          description: An unexpected error response.
components:
  schemas:
    ProjectServiceUpdateProjectBody:
      description: Request used to update a project.
      properties:
        object:
          description: >-
            Logical root object that serves as the basis for organizing and
            managing all

            information related to a repository.


            A project corresponds to a repository.
          properties:
            meta:
              $ref: '#/components/schemas/v1Meta'
            processing_status:
              $ref: '#/components/schemas/v1ProcessingStatus'
            spec:
              $ref: '#/components/schemas/v1ProjectSpec'
            tenant_meta:
              description: The tenant to which the project belongs.
              title: The tenant to which the project belongs.
              type: object
            uuid:
              description: The unique identifier of the project.
              readOnly: true
              type: string
          type: object
        request:
          $ref: '#/components/schemas/v1UpdateRequest'
      required:
        - meta
        - spec
      type: object
    v1Project:
      description: >-
        Logical root object that serves as the basis for organizing and managing
        all

        information related to a repository.


        A project corresponds to a repository.
      properties:
        meta:
          $ref: '#/components/schemas/v1Meta'
        processing_status:
          $ref: '#/components/schemas/v1ProcessingStatus'
        spec:
          $ref: '#/components/schemas/v1ProjectSpec'
        tenant_meta:
          $ref: '#/components/schemas/v1TenantMeta'
        uuid:
          description: The unique identifier of the project.
          readOnly: true
          type: string
      required:
        - meta
        - spec
      type: object
    googlerpcStatus:
      description: >-
        The `Status` type defines a logical error model that is suitable for

        different programming environments, including REST APIs and RPC APIs. It
        is

        used by [gRPC](https://github.com/grpc). Each `Status` message contains

        three pieces of data: error code, error message, and error details.


        You can find out more about this error model and how to work with it in
        the

        [API Design Guide](https://cloud.google.com/apis/design/errors).
      properties:
        code:
          description: |-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
          format: int32
          type: integer
        details:
          description: >-
            A list of messages that carry the error details.  There is a common
            set of

            message types for APIs to use.
          items:
            $ref: '#/components/schemas/googleprotobufAny'
          type: array
        message:
          description: >-
            A developer-facing error message, which should be in English. Any

            user-facing error message should be localized and sent in the

            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized

            by the client.
          type: string
      type: object
    v1Meta:
      description: Common fields for all Endor Labs resources.
      properties:
        annotations:
          additionalProperties:
            type: string
          description: >-
            Annotations can be used to attach metadata to a resource message.

            Annotation values can be small or large, structured or unstructured,

            and may include characters not permitted by labels.

            The keys may contain alphanumerics, underscores (_), dots (.) and
            dashes

            (-). The values of an annotation must be 16384 bytes or smaller.
          type: object
        create_time:
          description: |-
            Time the resource was created.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt.
          format: date-time
          readOnly: true
          type: string
        created_by:
          description: |-
            Name and authentication source of the user who created the object,
            for example, ewok@endor.ai@google@api-key.
          readOnly: true
          type: string
        description:
          description: Resource description. Must be less than 1024 bytes.
          type: string
        index_data:
          $ref: '#/components/schemas/v1IndexData'
        kind:
          description: >-
            Resource kind, for example, HelloResponse.

            Auto-generated using the protobuf message
            proto.MessageName().Name().
          readOnly: true
          type: string
        name:
          description: Resource name. Must be 63 characters or less.
          type: string
        parent_kind:
          description: Parent object resource kind, for example, Project.
          type: string
        parent_uuid:
          description: Parent object UUID.
          type: string
        references:
          additionalProperties:
            $ref: '#/components/schemas/googleprotobufAny'
          description: Map of objects referenced in a query API.
          readOnly: true
          type: object
        tags:
          description: >-
            List of tags attached to the resource.

            Tags can be used to select objects and to find collections of
            objects that

            satisfy certain conditions. A tag must be 255 characters or less.
          items:
            type: string
          type: array
        update_time:
          description: |-
            Time the resource was last updated.
            Note: Updated on all create/patch/delete operations.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt.
          format: date-time
          readOnly: true
          type: string
        updated_by:
          description: >-
            Name and authentication source of the last user who updated the
            object,

            for example, vulnerabilityingestor@endor.ai@x509.
          readOnly: true
          type: string
        upsert_time:
          description: |-
            Time the resource was last upserted.

            Note:
            create_time is only set the first time the resource is created.
            upsert_time is set every time the resource is upseted.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt.
          format: date-time
          readOnly: true
          type: string
        version:
          description: Message version.
          readOnly: true
          type: string
      required:
        - name
      type: object
    v1ProcessingStatus:
      properties:
        analytic_time:
          description: |-
            Last time a project was analyzed.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt.
          format: date-time
          type: string
        disable_automated_scan:
          description: >-
            This is a private package and it must not be scanned by the
            background

            scheduler. It will be scanned by an endorctl client instead.
            Default:

            false.
          type: boolean
        metadata:
          $ref: '#/components/schemas/v1ProcessingStatusMetadata'
        queue_time:
          description: |-
            Last time a project was queued.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt.
          format: date-time
          type: string
        scan_state:
          $ref: '#/components/schemas/v1ScanState'
        scan_time:
          description: |-
            Last time a project was ingested.

            Format: 2017-01-15T01:30:15.01Z
            RFC 3339: https://www.ietf.org/rfc/rfc3339.txt
          format: date-time
          type: string
      type: object
    v1ProjectSpec:
      properties:
        git:
          $ref: '#/components/schemas/v1GitSpec'
        ingestion_token:
          description: >-
            Third-party API authentication token to read project related
            information.
          readOnly: true
          type: string
        internal_reference_key:
          description: >-
            Unique key for the project generated by Endor Labs to simplify
            lookups.
          readOnly: true
          type: string
        is_archived:
          description: >-
            Indicates whether the project is archived.

            Archived projects are typically read-only and users can choose to
            scan or not scan the project in the app integrations settings.
          type: boolean
        model:
          $ref: '#/components/schemas/v1ModelSpec'
        platform_source:
          $ref: '#/components/schemas/v1PlatformSource'
        sbom:
          $ref: '#/components/schemas/v1SBOMSpec'
        scan_profile_uuid:
          type: string
        toolchain_profile_uuid:
          description: The toolchain required to build and scan the project.
          type: string
        unsupported:
          $ref: '#/components/schemas/v1UnsupportedSpec'
      required:
        - platform_source
      type: object
    v1UpdateRequest:
      description: Message used for all update requests.
      properties:
        force:
          description: |-
            Force will force the update of the resource if any
            checks fail.
          type: boolean
        update_mask:
          description: Fields to update. Defaults to all fields.
          type: string
      type: object
    v1TenantMeta:
      description: Tenant related data for the tenant containing the resource.
      properties:
        namespace:
          description: >-
            Namespaces are a way to organize organizational units into virtual

            groupings of resources. Namespaces must be a fully qualified name,

            for example, the child namespace of namespace "endor.prod" called
            "app"

            is called "endor.prod.app".
          type: string
      required:
        - namespace
      type: object
    googleprotobufAny:
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      type: object
    v1IndexData:
      description: |-
        IndexData is used to index the resource for search. It's an internal
        object.
      properties:
        data:
          items:
            type: string
          readOnly: true
          type: array
        search_score:
          description: >-
            search_score is the score of the resource for search. Internal use
            only.
          format: float
          readOnly: true
          type: number
        tenant:
          readOnly: true
          type: string
        will_be_deleted_at:
          description: Time that the resource will be deleted.
          format: date-time
          readOnly: true
          type: string
      type: object
    v1ProcessingStatusMetadata:
      properties:
        full_history_scan_time:
          format: date-time
          title: Last time a project was scanned with deep secrets scanning
          type: string
      type: object
    v1ScanState:
      default: SCAN_STATE_UNSPECIFIED
      description: |-
        Scan state for a project or package version.

         - SCAN_STATE_NOT_PROCESSED: Object has not been processed by the system yet.
        Set when the project or package is created for the first time.
        A new project or package version is automatically placed in this state.
         - SCAN_STATE_IDLE: Object has been scanned at least once.
         - SCAN_STATE_INGESTING: Object is being scanned.
         - SCAN_STATE_ANALYTIC: Object is being analyzed.
         - SCAN_STATE_UNREACHABLE: Object cannot be ingested because it is not reachable from the scheduler.
         - SCAN_STATE_REQUEST_FULL_RESCAN: Object is marked for a complete rescan.
        This only applies to OSS projects.
         - SCAN_STATE_REQUEST_INCREMENTAL_RESCAN: Object is marked for an incremental rescan, where only new packages
        discovered in the scan are added. Indicates that this project should be
        rescanned with a higher priority. Often because it is used by a customer
        and we need any new packages to be discovered and scanned with higher
        priority. If the project is put in this state, we will scan any new
        packages at high priority but we will not re-scan older packages.
         - SCAN_STATE_QUEUED: Object is queued to be scanned.
         - SCAN_STATE_QUARANTINED: Scan scheduling was unsuccessful due to a system errors. Object is
        quarantined from additional scheduling. Potentially object is an
        orphan or similar situations.
      enum:
        - SCAN_STATE_UNSPECIFIED
        - SCAN_STATE_NOT_PROCESSED
        - SCAN_STATE_IDLE
        - SCAN_STATE_INGESTING
        - SCAN_STATE_ANALYTIC
        - SCAN_STATE_UNREACHABLE
        - SCAN_STATE_REQUEST_FULL_RESCAN
        - SCAN_STATE_REQUEST_INCREMENTAL_RESCAN
        - SCAN_STATE_QUEUED
        - SCAN_STATE_QUARANTINED
      type: string
    v1GitSpec:
      description: |-
        Git repository project configuration.

        Fields of this object might differ from the Git host.
      properties:
        external_installation_id:
          description: |-
            Endor Labs GitHub app installation ID of this project.
            Optional and only available if the project is created through an
            installation.
          format: int64
          type: string
        full_name:
          description: >-
            Represents the Git namespace and its associated hierarchy.


            The format is "namespace/name", comprising the organization name and

            repository name.


            For example, yarpc/yarpc-go


            GitHub: curl https://api.github.com/repos/yarpc/yarpc-go | jq
            .full_name
          readOnly: true
          type: string
        git_clone_url:
          description: |-
            The Git clone URL.
            For example, git://github.com/yarpc/yarpc-go.git.

            The URL is stored as lower case letters to normalize searches.
          readOnly: true
          type: string
        http_clone_url:
          description: |-
            The HTTP clone URL.

            The following examples show valid URLs.

            https://github.com/yarpc/yarpc-go.git

            http://github.com/yarpc/yarpc-go.git

            https://my.github.com/a/b.git

            https://www.gitlab.com/a/b/c.git

            https://github.com/eclipse-vertx/vert.x.git

            https://github.com/jboss/jboss-ejb-api_spec.git

            The URL is stored as lower case letters to normalize searches.
          type: string
        invalid_installation:
          description: >-
            Indicates that Endor Labs installation no longer exists

            for this project and was potentially deleted. Endor Labs can no
            longer

            refresh or rescan this project.
          type: boolean
        organization:
          description: |-
            The organization where the repository is located.

            For example, yarpc

            GitHub: curl https://api.github.com/repos/yarpc/yarpc-go | jq
            .organization.login
          readOnly: true
          type: string
        path:
          description: >-
            The source control repository in the project without the
            organization.


            For example, yarpc-go


            GitHub: curl https://api.github.com/repos/yarpc/yarpc-go | jq .name
          readOnly: true
          type: string
        web_url:
          description: >-
            The web URL to view the repository.


            For example, https://github.com/yarpc/yarpc-go


            GitHub: curl https://api.github.com/repos/yarpc/yarpc-go | jq
            .html_url


            The URL is stored as lower case letters to normalize searches.
          readOnly: true
          type: string
      required:
        - http_clone_url
      type: object
    v1ModelSpec:
      properties:
        external_installation_id:
          description: >-
            Endor Labs Hugging Face installation ID of this project.

            Optional and only available if the project is created through an
            installation.
          type: string
        full_name:
          description: |-
            The author and model name.
            For example, author/model_name.
          type: string
        http_clone_url:
          description: |-
            The HTTP clone URL of the project.
            For example, https://huggingface.co/openai-community/gpt2.
          type: string
        provider:
          $ref: '#/components/schemas/v1AIModelProvider'
      required:
        - full_name
      type: object
    v1PlatformSource:
      default: PLATFORM_SOURCE_UNSPECIFIED
      description: Type of source control platform a resource was discovered on.
      enum:
        - PLATFORM_SOURCE_UNSPECIFIED
        - PLATFORM_SOURCE_GITHUB
        - PLATFORM_SOURCE_GITLAB
        - PLATFORM_SOURCE_GITSERVER
        - PLATFORM_SOURCE_BITBUCKET
        - PLATFORM_SOURCE_BINARY
        - PLATFORM_SOURCE_HUGGING_FACE
        - PLATFORM_SOURCE_AZURE
        - PLATFORM_SOURCE_ARCHIVE
        - PLATFORM_SOURCE_EXTERNAL_AI_SERVICE
        - PLATFORM_SOURCE_GITHUB_ENTERPRISE
      type: string
    v1SBOMSpec:
      properties:
        kind:
          $ref: '#/components/schemas/v1SBOMKind'
        main_component_purl:
          description: >-
            Package URL (PURL) is a standard to identify packages, libraries, or

            modules in an SBOM. Provides information about the package like
            name,

            version, and repository location.
          type: string
      required:
        - main_component_purl
        - kind
      type: object
    v1UnsupportedSpec:
      description: A project with a source code type that is not supported or not known.
      properties:
        name:
          description: >-
            Name of the unsupported project, which can be an unsupported clone
            URL or

            a package name.
          type: string
      required:
        - name
      type: object
    v1AIModelProvider:
      default: AI_MODEL_PROVIDER_UNSPECIFIED
      description: |-
        Provider the model comes from.

         - AI_MODEL_PROVIDER_HUGGING_FACE: The model comes from Hugging Face.
         - AI_MODEL_PROVIDER_OPENAI: The model comes from OpenAI.
         - AI_MODEL_PROVIDER_ANTHROPIC: The model comes from Anthropic.
         - AI_MODEL_PROVIDER_GOOGLE: The model comes from Google.
         - AI_MODEL_PROVIDER_AWS: The model comes from AWS.
         - AI_MODEL_PROVIDER_PERPLEXITY: The model comes from Perplexity.
         - AI_MODEL_PROVIDER_DEEPSEEK: The model comes from DeepSeek.
         - AI_MODEL_PROVIDER_AZUREOPENAI: The model comes from Azure OpenAI.
         - AI_MODEL_PROVIDER_CUSTOM: The model comes from a custom AI provider defined by the user.
      enum:
        - AI_MODEL_PROVIDER_UNSPECIFIED
        - AI_MODEL_PROVIDER_HUGGING_FACE
        - AI_MODEL_PROVIDER_OPENAI
        - AI_MODEL_PROVIDER_ANTHROPIC
        - AI_MODEL_PROVIDER_GOOGLE
        - AI_MODEL_PROVIDER_AWS
        - AI_MODEL_PROVIDER_PERPLEXITY
        - AI_MODEL_PROVIDER_DEEPSEEK
        - AI_MODEL_PROVIDER_AZUREOPENAI
        - AI_MODEL_PROVIDER_CUSTOM
      type: string
    v1SBOMKind:
      default: SBOM_KIND_UNSPECIFIED
      description: SBOM type.
      enum:
        - SBOM_KIND_UNSPECIFIED
        - SBOM_KIND_CYCLONEDX
        - SBOM_KIND_SPDX
      type: string

````